#include <iostream>
#include <cmath>
using namespace std;

// from 0 to cut - 1, the array is sorted
// from cut to len, the array is unsorted
void insertionSort (int array[], int cut, int len)
{
	if (cut <= len)
	{
		int cur = array[cut];
		
		// insert array[cut] into the proper position
		if (array[cut] < array[0])
		{
			// insert to the first position (index 0)
			for (int i = cut; i > 0; i--)
				array[i] = array[i - 1]; 
			array[0] = cur; 
		}
		else 
		{
			// search for the position to insert
			for (int i = 1; i < cut; i++)
			{
				if (array[cut] < array[i])
				{
					// insert to index i 
					for (int j = cut; j > i; j--)
						array[j] = array[j - 1]; 
					array[i] = cur; 
				}
			}
		}

		// display the current array
		for (int i = 0; i < len; i++)
		{
			cout << array[i] << " ";
			if (i == cut)
				cout << "| ";
		}
		cout << endl;
			
		insertionSort (array, cut + 1, len);
	}
}

int main ()
{
	int array[10] = {0};
	for (int i = 0; i < 10; i++)
		cin >> array[i];
	
	insertionSort (array, 0, 9);
	
	for (int i = 0; i < 10; i++)
		cout << array[i] << " ";
	cout << endl;
	
	return 0;
}
