#include <iostream>
#include <ctime>
#include <iomanip>
using namespace std;

double fibRecursive (int n)
{
	if (n == 1)
		return 1;
	else if (n == 2)
		return 1;
	else // two recursive calls
		return (fibRecursive (n-1) + fibRecursive (n-2));
}

double fibRepetitive (int n)
{
	if (n == 1)
		return 1;
	else if (n == 2)
		return 1;
	else
	{
		double* fib = new double[n];
		fib[0] = 1;
		fib[1] = 1;
		
		for (int i = 2; i < n; i++)
			fib[i] = fib[i - 1] + fib[i - 2];
		
		double result = fib[n - 1];
		delete[] fib;
	  
	    return result;
	}
}

int main ()
{
	int n = 0;
	cin >> n; 
	
	// algorithm 1
	long int stTime = 0, endTime = 0;
	double duration = 0;	
	stTime = clock();

	cout << setprecision(100) << fibRepetitive (n) << endl; 
	
	endTime = clock();
	duration = static_cast<double> (endTime - stTime);
	duration = duration / CLK_TCK;
	cout << "seconds for algorithm 1: " << setprecision(5) << duration << endl; 

	// algorithm 2
	stTime = clock();
	
	cout << setprecision(100) << fibRecursive (n) << endl; 
	
	endTime = clock();
	duration = static_cast<double> (endTime - stTime);
	duration = duration / CLK_TCK;
	cout << "seconds for algorithm 2: " << setprecision(5) << duration << endl; 

}
